var DGT = DGT || {}
DGT.MVDF = DGT.MVDF || {}
DGT.MVDF.protocols = DGT.MVDF.protocols || {}
{
  // troop page fix
  let bte = ()=>{}
  if (DataManager.processBTEPages) {
    DataManager.processBTEPages = bte
    bte = DataManager.processBTEPages.bind(DataManager)
  }
  // disable SceneManager until restartSM() is called
  let old_run = SceneManager.goto
  SceneManager.goto = function(cl) {
    if (!window['restartSM']) {
      // allow it to go past boot, but not not title screen so databases get loaded
      if (cl !== Scene_Boot) {
        window['restartSM'] = ()=>{
          bte()
          document.querySelector('#dfw').style.opacity = 0
          old_run.call(this, cl)
          SceneManager.goto = old_run
          window['enableAllThoseEvents'] = true
        }
        DGT.MVDF.protocols.restartscenemanager = restartSM
        return
      }
    } else {
      return
    }
    old_run.call(this, cl)
  }
  // disable some default input stuff while this boolean is false
  window['enableAllThoseEvents'] = false
  const enabler = {
    apply: (t,tt,a)=>window['enableAllThoseEvents']?Reflect.apply(t,tt,a):undefined
  }
  if (Input) {Input._onKeyDown = new Proxy(Input._onKeyDown, enabler)}
  if (KeyboardInput) {KeyboardInput._onKeyDown = new Proxy(KeyboardInput._onKeyDown, enabler)}
  if (TouchInput) {TouchInput._onMouseDown = new Proxy(TouchInput._onMouseDown, enabler)}
  if (TouchInput) {TouchInput._onWheel = new Proxy(TouchInput._onWheel, enabler)}
  // defocus input elements on enter press
  document.addEventListener('keyup', (e)=>{
    if (!window['enableAllThoseEvents']) {
      if (e.code === 'Enter') {
        //e.preventDefault()
        return document.activeElement.blur()
      }
    }
  })
  // map loading stufe
  window['Yanfly'] = window['Yanfly'] || {} // use yanflys preloaded maps if they exist
  Yanfly.PreloadedMaps = Yanfly.PreloadedMaps || []
  DGT.MVDF.loadMapData = function(mapId, callback) {
    mapId = mapId.clamp(1, 999);
    if (Yanfly.PreloadedMaps[mapId]) return;
    if(!!Utils.isOptionValid("test")) {
      var src = 'Map%1.json'.format(mapId.padZero(3));
      var xhr = new XMLHttpRequest();
      var url = 'data/' + src;
      xhr.open('GET', url);
      xhr.overrideMimeType('application/json');
      xhr.onload = function() {
        if (xhr.status < 400) {
          Yanfly.PreloadedMaps[mapId] = JSON.parse(xhr.responseText);
          callback(Yanfly.PreloadedMaps[mapId])
        }
      };
      xhr.onerror = function() {
        console.info("missing " + src + " but its probably fine")
      };
      Yanfly.PreloadedMaps[mapId] = null;
      xhr.send();
    }
    else {
      const path = require('path');
      const fs = require('fs');
      var base = path.dirname(process.mainModule.filename);	
      let filename = 'Map%1.KEL'.format(mapId.padZero(3));
      Yanfly.PreloadedMaps[mapId] = null;	
      fs.readFile(base + "/data/" + filename, (err, data) => {
        if (err) {return console.info('missing ' + filename + ' but its probably fine')}
        try {
          data = Encryption.decrypt(data);
          Yanfly.PreloadedMaps[mapId] = JSON.parse(data.toString());
          callback(Yanfly.PreloadedMaps[mapId])
        } catch (_) {
          console.warn('failed decryption of ' + filename)
        }
      })
    }
  };
}